#![feature(const_fn)]
#![feature(extern_types)]

#[cfg(test)]
#[macro_use]
extern crate quickcheck;

#[macro_use]
mod dbg;

#[macro_use]
mod paging;

pub mod cpu2;

pub mod js_api;
pub mod profiler;

mod analysis;
mod codegen;
mod config;
mod cpu;
mod cpu_context;
mod gen;
mod global_pointers;
mod jit;
mod jit_instructions;
mod leb;
mod modrm;
mod opstats;
mod page;
mod prefix;
mod regs;
mod state_flags;
mod util;
mod wasmgen;
